﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp14
{
    public partial class Form1 : Form
    {
        const int WIDTH = 320, HEIGHT = 240;
        Bitmap bmap_src = new Bitmap(WIDTH, HEIGHT);
        Bitmap bmap_gray = new Bitmap(WIDTH, HEIGHT);
        Bitmap bmap_bin = new Bitmap(WIDTH, HEIGHT);
        Bitmap bmap_thr = new Bitmap(WIDTH, HEIGHT);
        int midrange, median, threshold;
        int[] his = new int[256];
        int[,] pdata = new int[WIDTH, HEIGHT];

        public Form1()
        {
            InitializeComponent();
        }

        private int[,] GetGrayData(Bitmap bmap)
        {
            int i, j;
            Color color1;
            int r, g, b, y;
            int[,] data = new int[WIDTH, HEIGHT];

            for (j = 0; j < HEIGHT; j++)
                for (i = 0; i < WIDTH; i++)
                {
                    color1 = bmap.GetPixel(i, j);
                    r = color1.R;
                    g = color1.G;
                    b = color1.B;
                    y = (r * 2 + g * 4 + b) / 7;
                    data[i, j] = y;
                }
            return data;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i, j, y;
            int n05 = (int)(WIDTH * HEIGHT * 0.05);
            int n50 = WIDTH * HEIGHT / 2;
            int level05, level95;
            int integration;

            //原画像を読み込む
            bmap_src = new Bitmap("gent.jpg");
            //原画像をグレイピクセルデータにする
            pdata = GetGrayData(bmap_src);
            //ピクセルデータでグレイ画像を生成する
            for (j = 0; j < HEIGHT; j++)
                for (i = 0; i < WIDTH; i++)
                {
                    y = pdata[i, j];
                    bmap_gray.SetPixel(i, j, Color.FromArgb(y, y, y));
                }
            //グレイ画像のヒストグラムを採る
            for (i = 0; i < 256; i++)
                his[i] = 0;
            for (j = 0; j < HEIGHT; j++)
                for (i = 0; i < WIDTH; i++)
                    his[pdata[i, j]]++;
            //ヒストグラムから中点値（midrange）と中央値（median）を求める
            integration = 0;
            i = 0;
            do
            {
                integration += his[i];
                i++;
            } while (integration < n05);
            level05 = i - 1;
            do
            {
                integration += his[i];
                i++;
            } while (integration < n50);
            median = i - 1;
            integration = 0;
            i = 255;
            do
            {
                integration += his[i];
                i--;
            } while (integration < n05);
            level95 = i + 1;
            midrange = (level05 + level95) / 2;
            //しきい値の初期設定をmidrangeにする
            threshold = midrange;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics gr = e.Graphics;

            int X0 = 10, Y0 = 10;
            int X1 = WIDTH + 20, Y1 = Y0;
            int X2 = X0, Y2 = HEIGHT + 20;
            int X3 = X1 + 30, Y3 = Y2;
            int i, j, y;
            String string1;

            //画像を左上に表示する
            gr.DrawImage(bmap_src, X0, Y0);
            //グレイ画像を右上に表示する
            gr.DrawImage(bmap_gray, X1, Y1);
            //ピクセルデータでヒストグラムを右下に描く
            gr.DrawRectangle(Pens.Black, X3, Y3 + 20, 256, 51);
            for (i = 0; i < 256; i++)
                gr.DrawLine(Pens.Gray, X3 + i, Y3 + 70, X3 + i, Y3 + 70 - his[i] / 20);
            //ヒストグラムに中点値と中央値を表示する
            gr.DrawLine(Pens.Blue, X3 + midrange, Y3 + 70, X3 + midrange, Y3 + 20);
            gr.DrawLine(Pens.Red, X3 + median, Y3 + 70, X3 + median, Y3 + 20);
            //中点値と中央値を表示する
            string1 = String.Format("中点値 = {0, 3}", midrange);
            gr.DrawString(string1, Font, Brushes.Blue, X3, Y3 + 90);
            string1 = String.Format("中央値 = {0, 3}", median);
            gr.DrawString(string1, Font, Brushes.Red, X3, Y3 + 110);
            //ピクセルデータとしきい値で二値画像を生成する
            for (j = 0; j < HEIGHT; j++)
                for (i = 0; i < WIDTH; i++)
                {
                    if (pdata[i, j] > threshold) y = 255;
                    else y = 0;
                    bmap_bin.SetPixel(i, j, Color.FromArgb(y, y, y));
                }
            //二値画像を左下に表示する
            gr.DrawImage(bmap_bin, X2, Y2);
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            threshold = midrange;
            Invalidate();
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            threshold = median;
            Invalidate();
        }
    }
}
