﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp16
{
    public partial class Form1 : Form
    {
        const int WIDTH = 320, HEIGHT = 240;
        bool[,] pdata = new bool[WIDTH, HEIGHT];       //一回ごとの細線化の結果
        bool[,] pdata_old = new bool[WIDTH, HEIGHT];   //pdataのコピー
        bool change_flag;

        public Form1()
        {
            InitializeComponent();
        }

        private bool ThinImage(bool[,] pd, int i, int j, int start)
        {
            bool[] p = new bool[8];
            bool product, sum;
            bool result = true;

            //周辺のデータをコピーする
            p[0] = pd[i - 1, j - 1];
            p[1] = pd[i - 1, j];
            p[2] = pd[i - 1, j + 1];
            p[3] = pd[i, j + 1];
            p[4] = pd[i + 1, j + 1];
            p[5] = pd[i + 1, j];
            p[6] = pd[i + 1, j - 1];
            p[7] = pd[i, j - 1];
            //消去できるかの判定をする
            for (int k = start; k < start + 3; k++)
            {
                product = p[k % 8] && p[(k + 1) % 8] && p[(k + 2) % 8];
                sum = p[(k + 4) % 8] || p[(k + 5) % 8] || p[(k + 6) % 8];
                if (product && !sum)
                {
                    result = false;       //消去する
                    change_flag = true;   //変更があった
                    break;                //これ以上調べる必要がない
                }
            }
            return result;
        }

        private void CopyToOld()
        {
            int i, j;
            for (j = 0; j < HEIGHT; j++)
                for (i = 0; i < WIDTH; i++)
                    pdata_old[i, j] = pdata[i, j];
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int X0 = 10, Y0 = 10;
            int X1 = 340, Y1 = 10;
            const int UPPER_LEFT = 2, LOWER_RIGHT = 6, UPPER_RIGHT = 0, LOWER_LEFT = 4;
            Color color1;
            int i, j;

            //細線化画像を用意する
            Bitmap bmap_thin = new Bitmap(WIDTH, HEIGHT);
            //原画像を読み込む
            Bitmap bmap_src = new Bitmap("fingerprint.png");
            //原画像を左に表示する
            g.DrawImage(bmap_src, X0, Y0);
            //原画像をピクセルデータにする（周辺を除く、周辺はfalseのまま）
            for (j = 1; j < HEIGHT - 1; j++)
                for (i = 1; i < WIDTH - 1; i++)
                {
                    color1 = bmap_src.GetPixel(i, j);
                    if (color1.R > 127) pdata[i, j] = false;   //白
                    else pdata[i, j] = true;                   //黒
                }
            //細線化を実行する
            do
            {
                change_flag = false;
                //左上から
                CopyToOld();
                for (j = 1; j < HEIGHT - 1; j++)
                    for (i = 1; i < WIDTH - 1; i++)
                        if (pdata_old[i, j]) pdata[i, j] = ThinImage(pdata_old, i, j, UPPER_LEFT);
                //右下から
                CopyToOld();
                for (j = HEIGHT - 2; j >= 1; j--)
                    for (i = WIDTH - 2; i >= 1; i--)
                        if (pdata_old[i, j]) pdata[i, j] = ThinImage(pdata_old, i, j, LOWER_RIGHT);
                //右上から
                CopyToOld();
                for (j = 1; j < HEIGHT - 1; j++)
                    for (i = WIDTH - 2; i >= 1; i--)
                        if (pdata_old[i, j]) pdata[i, j] = ThinImage(pdata_old, i, j, UPPER_RIGHT);
                //左下から
                CopyToOld();
                for (j = HEIGHT - 2; j >= 1; j--)
                    for (i = 1; i < WIDTH - 1; i++)
                        if (pdata_old[i, j]) pdata[i, j] = ThinImage(pdata_old, i, j, LOWER_LEFT);
                //ピクセルデータpdataを細線化画像に変換する
                for (j = 0; j < HEIGHT; j++)
                    for (i = 0; i < WIDTH; i++)
                    {
                        if (pdata[i, j]) bmap_thin.SetPixel(i, j, Color.Black);
                        else bmap_thin.SetPixel(i, j, Color.White);
                    }
                //細線化画像を表示する
                g.DrawImage(bmap_thin, X1, Y1);
                //時間をかけて分かり易くする
                System.Threading.Thread.Sleep(100);
            } while (change_flag);
        }
    }
}
