﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp17
{
    public partial class Form1 : Form
    {
        int X0 = 50, Y0 = 60;
        const int SIZE = 4;
        const int SIZE10 = SIZE * 10, SIZE50 = SIZE * 50, SIZE100 = SIZE * 100;
        const int LINE_LINE = 100, LINE_LOG = 101, LOG_LINE = 102, LOG_LOG = 103;
        const int MAX_POINTS = 20;       //マウス入力できるデータ点の最大数      
        PointF[] data_value = new PointF[MAX_POINTS];  //データ点の値の配列       
        int data_number = 0;                   //入力されているデータ点の数       
        int graph_type = LINE_LINE;    //最初はグラフ種別を「線→線」に設定     
        PointF[] fitting_value = new PointF[SIZE100];  //あてはめ曲線の数値の配列
        bool fitting_flag = false;       //あてはめが実施されればtrueになる

        public Form1()
        {
            InitializeComponent();
        }

        private PointF ConvertPositionToValue(int graph_type, PointF position)
        {
            PointF point_value = new PointF(0F, 0F);
            if (graph_type == LINE_LINE || graph_type == LINE_LOG)
                point_value.X = position.X / (float)SIZE;
            else
                point_value.X = (float)(Math.Pow(10, position.X / (float)SIZE50));
            if (graph_type == LINE_LINE || graph_type == LOG_LINE)
                point_value.Y = (SIZE100 - position.Y) / (float)SIZE;
            else
                point_value.Y = (float)(Math.Pow(10, (SIZE100 - position.Y) / (float)SIZE50));
            return point_value;
        }

        private PointF ConvertValueToPosition(int graph_type, PointF value)
        {
            PointF position = new PointF(0F, 0F);
            if (graph_type == LINE_LINE || graph_type == LINE_LOG)
                position.X = SIZE * value.X;
            else
                position.X = SIZE50 * (float)(Math.Log10(value.X));
            if (graph_type == LINE_LINE || graph_type == LOG_LINE)
                position.Y = SIZE100 - SIZE * value.Y;
            else
                position.Y = SIZE100 - SIZE50 * (float)(Math.Log10(value.Y));
            return position;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            int i, j;
            String string1;
            float x, y, x_old = 0F, y_old = 0F;
            PointF position;
            RectangleF graph_area = new RectangleF(X0, Y0, SIZE100, SIZE100);

            //グラフ用紙を作成する
            //横軸（縦線）
            if (graph_type == LINE_LINE || graph_type == LINE_LOG)  //線形
            {
                for (i = 0; i <= 100; i++)
                    g.DrawLine(Pens.LightGray, X0 + SIZE * i, Y0, X0 + SIZE * i, Y0 + SIZE100);
                for (i = 0; i <= 10; i++)
                {
                    g.DrawLine(Pens.Gray, X0 + SIZE10 * i, Y0, X0 + SIZE10 * i, Y0 + SIZE100);
                    string1 = String.Format("{0}", 10 * i);
                    g.DrawString(string1, Font, Brushes.Black, X0 - 10 + SIZE10 * i, Y0 + SIZE100 + 10);
                }
            }
            else                                                    //対数
            {
                for (j = 0; j <= 1; j++)
                    for (i = 0; i < 20; i++)
                    {
                        x = (int)(X0 + SIZE50 * (j + Math.Log10((i + 1) / 2.0)));
                        if (i % 2 == 1)
                        {
                            g.DrawLine(Pens.Gray, x, Y0, x, Y0 + SIZE100);
                            string1 = String.Format("{0}", (i / 2 + 1) * Math.Pow(10, j));
                            g.DrawString(string1, Font, Brushes.Black, x - 8, Y0 + SIZE100 + 10);
                        }
                        else
                            g.DrawLine(Pens.LightGray, x, Y0, x, Y0 + SIZE100);
                    }
            }
            //縦軸（横線）
            if (graph_type == LINE_LINE || graph_type == LOG_LINE)  //線形
            {
                for (i = 0; i <= 100; i++)
                    g.DrawLine(Pens.LightGray, X0, Y0 + SIZE * i, X0 + SIZE100, Y0 + SIZE * i);
                for (i = 0; i <= 10; i++)
                {
                    g.DrawLine(Pens.Gray, X0, Y0 + SIZE10 * i, X0 + SIZE100, Y0 + SIZE10 * i);
                    string1 = String.Format("{0, 3:D}", 10 * (10 - i));
                    g.DrawString(string1, Font, Brushes.Black, X0 - 30, Y0 - 6 + SIZE10 * i);
                }
            }
            else                                                    //対数
            {
                for (j = 0; j <= 1; j++)
                    for (i = 0; i < 20; i++)
                    {
                        y = (float)(Y0 + SIZE100 - SIZE50 * (j + Math.Log10((i + 1) / 2.0)));
                        if (i % 2 == 1)
                        {
                            g.DrawLine(Pens.Gray, X0, y, X0 + SIZE100, y);
                            string1 = String.Format("{0, 3:D}", (int)((i / 2 + 1) * Math.Pow(10, j)));
                            g.DrawString(string1, Font, Brushes.Black, X0 - 25, y - 5);
                        }
                        else
                            g.DrawLine(Pens.LightGray, X0, y, X0 + SIZE100, y);
                    }
            }
            Pen pen1 = new Pen(Color.Black, 2F);
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            //データ点を表示する
            for (i = 0; i < data_number; i++)
            {
                position = ConvertValueToPosition(graph_type, data_value[i]);
                g.DrawEllipse(pen1, X0 + position.X - 3, Y0 + position.Y - 3, 6F, 6F);
            }
            //あてはめ線を描く
            if (fitting_flag == true)
            {
                for (i = 0; i < SIZE100; i++)
                {
                    position = ConvertValueToPosition(graph_type, fitting_value[i]);
                    x = X0 + position.X;
                    y = Y0 + position.Y;
                    if (i != 0 && graph_area.Contains(x, y))
                        g.DrawLine(pen1, x_old, y_old, x, y);
                    x_old = x;
                    y_old = y;
                }
            }
        }

        private void LineLine_Click(object sender, EventArgs e)
        {
            graph_type = LINE_LINE;
            Invalidate();
        }     

        private void LineLog_Click(object sender, EventArgs e)
        {
            graph_type = LINE_LOG;
            Invalidate();
        }

        private void LogLine_Click(object sender, EventArgs e)
        {
            graph_type = LOG_LINE;
            Invalidate();
        }

        private void LogLog_Click(object sender, EventArgs e)
        {
            graph_type = LOG_LOG;
            Invalidate();
        }

        private void Fitting_Click(object sender, EventArgs e)
        {
            Graphics g = CreateGraphics();

            int i;
            float x, y, x_sum = 0F, y_sum = 0F, xx_sum = 0F, xy_sum = 0F;
            float a, b;
            PointF[] position = new PointF[SIZE100];

            for (i = 0; i < data_number; i++)
            {
                x = ConvertValueToPosition(graph_type, data_value[i]).X;
                y = ConvertValueToPosition(graph_type, data_value[i]).Y;
                x_sum += x;
                y_sum += y;
                xx_sum += x * x;
                xy_sum += x * y;
            }
            a = (data_number * xy_sum - x_sum * y_sum) / (data_number * xx_sum - x_sum * x_sum);
            b = (y_sum - a * x_sum) / data_number;
            for (i = 0; i < SIZE100; i++)
            {
                position[i].X = i;
                position[i].Y = a * i + b;
                fitting_value[i] = ConvertPositionToValue(graph_type, position[i]);
            }
            fitting_flag = true;
            Invalidate();
        }

        private void CancelFitting_Click(object sender, EventArgs e)
        {
            fitting_flag = false;
            Invalidate();
        }

        private void CancelAll_Click(object sender, EventArgs e)
        {
            data_number = 0;
            fitting_flag = false;
            Invalidate();
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            Graphics g = CreateGraphics();

            PointF position = new PointF(0F, 0F);
            PointF value = new PointF(0F, 0F);
            Rectangle graph_area = new Rectangle(X0, Y0, SIZE100, SIZE100);

            //前の表示を消す
            g.FillRectangle(Brushes.White, X0 - 5, Y0 + SIZE100 + 40, 200, 20);
            //グラフの範囲内であれば
            if (graph_area.Contains(e.X, e.Y))
            {
                //データ値に変換する
                position.X = e.X - X0;
                position.Y = e.Y - Y0;
                value = ConvertPositionToValue(graph_type, position);
                //前の表示を消して、新しいデータ値を表示する
                String string1;
                string1 = String.Format("X={0}, Y={1}", value.X, value.Y);
                g.DrawString(string1, Font, Brushes.Black, X0, Y0 + SIZE100 + 44);
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            Graphics g = CreateGraphics();

            PointF position = new PointF(0F, 0F);
            PointF value = new PointF(0F, 0F);
            Rectangle graph_area = new Rectangle(X0, Y0, SIZE100, SIZE100);

            //グラフ用紙の範囲内であれば
            if (graph_area.Contains(e.X, e.Y))
            {
                //データ値に変換する
                position.X = e.X - X0;
                position.Y = e.Y - Y0;
                try
                {
                    data_value[data_number] = ConvertPositionToValue(graph_type, position);
                    data_number++;
                }
                catch (IndexOutOfRangeException)
                {
                    MessageBox.Show("入力点の数が多すぎます", "エラー", MessageBoxButtons.OK);
                }
                //データ点を描画する
                Pen pen1 = new Pen(Color.Black, 2F);
                g.DrawEllipse(pen1, e.X - 3F, e.Y - 3F, 6F, 6F);
            }
        }
    }
}
