﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Numerics;    //Complex用に追加する

namespace WindowsFormsApp18
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int X0 = 50, X1 = 320;
            int Y0 = 30, Y1 = 180, Y2 = 380, Y3 = 420;
            int DECADE = 6;
            int d, i;
            double f;
            int x, y, x_old = 0, y_old = 0;       //仮設定
            String[] horiscale = { "1", "10", "100", "1k", "10k", "100k", "1M" };
            String[] vertscale = { " 60dB", " 40dB", " 20dB", "  0dB", "-20dB", "-40dB", "-60dB", "-80dB" };
            double R = 1.0;    //R = 1ohm
            double L = 1.0E-3; //L = 1mH
            double C = 1.0E-8; //C = 0.01uF
            double frequency, omega, ratio_abs;
            Complex zl, zc, ratio, zpara;

            //縦線を引く
            for (d = 0; d < DECADE; d++)
                for (f = 1.0; f <= 10.0; f += 1.0)
                {
                    x = X0 + (int)((d + Math.Log10(f)) * 100);
                    g.DrawLine(Pens.Black, x, Y0, x, Y2);
                }
            //横線を引く
            for (i = 0; i < 8; i++)
                g.DrawLine(Pens.Black, X0, Y2 - i * 50, X0 + DECADE * 100, Y2 - i * 50);
            //横軸の目盛を入れる
            for (i = 0; i <= DECADE; i++)
                g.DrawString(horiscale[i], Font, Brushes.Black, 40 + i * 100, Y2 + 10);
            //縦軸の目盛を入れる
            for (i = 0; i < 8; i++)
                g.DrawString(vertscale[i], Font, Brushes.Black, 6, Y0 - 6 + i * 50);
            //横軸の説明を入れる
            g.DrawString("周波数(Hz)", Font, Brushes.Black, X1, Y3);
            //周波数特性のグラフを描く
            Pen pen1 = new Pen(Brushes.Black, 2);
            for (d = 0; d < DECADE; d++)
                for (f = 1.0; f < 10.0; f += 0.1)
                {
                    frequency = f * Math.Pow(10, d);
                    omega = 2 * Math.PI * frequency;       //ω = 2πf
                    zl = new Complex(0, omega * L);        //zl = jωL
                    zc = new Complex(0, -1 / (omega * C)); //zc = 1 / jωC

                    //-------- ローパスフィルタの場合はこちらを使う --------
                    ratio = zc / (R + zl + zc);
                    //------------------------------------------------------

                    //------- バンドパスフィルタの場合はこちらを使う -------
                    //zpara = zl * zc / (zl + zc);
                    //ratio = zpara / (250 + zl + zc + zpara);
                    //------------------------------------------------------

                    ratio_abs = ratio.Magnitude;
                    x = X0 + (int)((d + Math.Log10(f)) * 100);
                    y = Y1 - (int)(Math.Log10(ratio_abs) * 50);
                    if ((d != 0 || f != 1.0) && y < Y1 + 200)
                        g.DrawLine(pen1, x_old, y_old, x, y);
                    x_old = x;
                    y_old = y;
                }
        }
    }
}
