﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Numerics;   //Complex用に追加

namespace WindowsFormsApp19
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private delegate Complex Function(Complex z);

        private void DrawConformalMap(Function function1, double range, double ratio)
        {
            Graphics g = CreateGraphics();

            int X0 = 125, Y0 = 170;
            int X1 = 460, Y1 = 170;
            int WIDTH = 400, HEIGHT = 300;
            Rectangle area = new Rectangle(X1 - WIDTH / 2, Y1 - HEIGHT / 2, WIDTH, HEIGHT);
            double x, y;
            int xx0, yy0, xx0_old = 0, yy0_old = 0;
            int xx1, yy1, xx1_old = 0, yy1_old = 0;
            Complex z, w;
            double p, theta;

            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;

            //写像後図形の枠を描く
            g.DrawRectangle(Pens.Black, area);
            //網目を描く
            for (x = -100; x <= 100; x += 10)    //原図形の縦線に沿って
                for (y = -100; y <= 100; y += 0.2)
                {
                    //原図形
                    xx0 = X0 + (int)x;
                    yy0 = Y0 - (int)y;
                    if (y != -100)
                        g.DrawLine(Pens.Gray, xx0_old, yy0_old, xx0, yy0);
                    xx0_old = xx0;
                    yy0_old = yy0;
                    //等角写像の図形
                    z = new Complex(x * range / 100, y * range / 100);
                    w = function1(z);
                    xx1 = X1 + (int)(w.Real * ratio);
                    yy1 = Y1 - (int)(w.Imaginary * ratio);
                    if (y != -100 && area.Contains(xx1, yy1))
                        g.DrawLine(Pens.Gray, xx1_old, yy1_old, xx1, yy1);
                    xx1_old = xx1;
                    yy1_old = yy1;
                }
            for (y = -100; y <= 100; y += 10)
                for (x = -100; x <= 100; x += 0.2)
                {
                    //原図形
                    xx0 = X0 + (int)x;
                    yy0 = Y0 - (int)y;
                    if (x != -100)
                        g.DrawLine(Pens.Silver, xx0_old, yy0_old, xx0, yy0);
                    xx0_old = xx0;
                    yy0_old = yy0;
                    //等角写像の図形
                    z = new Complex(x * range / 100, y * range / 100);
                    w = function1(z);
                    xx1 = X1 + (int)(w.Real * ratio);
                    yy1 = Y1 - (int)(w.Imaginary * ratio);
                    if (x != -100 && area.Contains(xx1, yy1))
                        g.DrawLine(Pens.Silver, xx1_old, yy1_old, xx1, yy1);
                    xx1_old = xx1;
                    yy1_old = yy1;
                }
            //円を描く
            for (p = 0.0; p < 2.0; p += 0.01)
            {
                theta = Math.PI * p;
                x = Math.Cos(theta) * 80 + 10;
                y = Math.Sin(theta) * 80 + 10;
                //原図形
                xx0 = X0 + (int)x;
                yy0 = Y0 - (int)y;
                if (p != 0.0)
                    g.DrawLine(Pens.Black, xx0_old, yy0_old, xx0, yy0);
                xx0_old = xx0;
                yy0_old = yy0;
                //等角写像の図形
                z = new Complex(x * range / 100, y * range / 100);
                w = function1(z);
                xx1 = X1 + (int)(w.Real * ratio);
                yy1 = Y1 - (int)(w.Imaginary * ratio);
                if (p != 0.0 && area.Contains(xx1, yy1))
                    g.DrawLine(Pens.Black, xx1_old, yy1_old, xx1, yy1);
                xx1_old = xx1;
                yy1_old = yy1;
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            //以下のコードの中から一つを選ぶ
            //DrawConformalMap(z => z * z, 1, 60);
            //DrawConformalMap(z => 1 / z, 1, 50);
            //DrawConformalMap(z => Complex.Sqrt(z), 1, 100);
            //DrawConformalMap(z => Complex.Exp(z), Math.PI, 20);
            //DrawConformalMap(z => Complex.Sin(z), Math.PI, 20);
            //DrawConformalMap(z => Complex.Cos(z), Math.PI, 20);
            //DrawConformalMap(z => Complex.Log(z), 1, 50);
            DrawConformalMap(z => (1 + Complex.Exp(z)) / (1 - Complex.Exp(z)), Math.PI, 40);
            //DrawConformalMap(z => (z - 1) / (z + 1), 0.8, 20);
        }
    }
}
