﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp5
{
    public partial class Form1 : Form
    {
        Boolean slow_flag = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            int X0 = 10, Y0 = 60;     //横軸グラフ用原点
            int X1 = 190, Y1 = 60;    //縦軸グラフ用原点
            int X2 = 20, Y2 = 240;    //リサージュグラフ用原点
            int SIZE = 16;            //最小目盛間隔
            float time;
            float x, y;
            float xx0, yy0, xx0_old = 0, yy0_old = 0;       //横軸グラフ物理座標
            float xx1, yy1, xx1_old = 0, yy1_old = 0;       //縦軸グラフ物理座標
            float xx2, yy2, xx2_old = 0, yy2_old = 0;       //リサージュグラフ物理座標
            int freq_x = (int)numericUpDown1.Value;         //横軸周波数
            int freq_y = (int)numericUpDown2.Value;         //縦軸周波数
            float omega_x = (float)(2 * Math.PI * freq_x);  //横軸角周波数
            float omega_y = (float)(2 * Math.PI * freq_y);  //縦軸角周波数
            float phi1 = hScrollBar1.Value / 100.0F;        //φの値（πに対する倍率）
            float phi = (float)(phi1 * Math.PI);            //計算に使用するφ

            //位相シフトを表示する
            if (phi1 == 0.0) label5.Text = "   0";
            else if (phi1 == 1.0) label5.Text = "  π";
            else if (phi1 == -1.0) label5.Text = " -π";
            else label5.Text = String.Format("{0}π", phi1);
            //グラフの背景を黒にする
            g.FillRectangle(Brushes.Black, X0, Y0, 10 * SIZE, 10 * SIZE);    //横軸グラフ用
            g.FillRectangle(Brushes.Black, X1, Y1, 10 * SIZE, 10 * SIZE);    //縦軸グラフ用
            g.FillRectangle(Brushes.Black, X2, Y2, 20 * SIZE, 20 * SIZE);    //リサージュグラフ用
            //グラフに目盛を入れる           
            for (int i = 0; i <= 10; i++)
            {
                //横軸グラフ用
                g.DrawLine(Pens.LightGray, X0 + i * SIZE, Y0, X0 + i * SIZE, Y0 + 10 * SIZE);
                g.DrawLine(Pens.LightGray, X0, Y0 + i * SIZE, X0 + 10 * SIZE, Y0 + i * SIZE);
                //縦軸グラフ用
                g.DrawLine(Pens.LightGray, X1 + i * SIZE, Y1, X1 + i * SIZE, Y1 + 10 * SIZE);
                g.DrawLine(Pens.LightGray, X1, Y1 + i * SIZE, X1 + 10 * SIZE, Y1 + i * SIZE);
                //リサージュグラフ用
                g.DrawLine(Pens.LightGray, X2 + i * 2 * SIZE, Y2, X2 + i * 2 * SIZE, Y2 + 20 * SIZE);
                g.DrawLine(Pens.LightGray, X2, Y2 + i * 2 * SIZE, X2 + 20 * SIZE, Y2 + i * 2 * SIZE);
            }
            //各種グラフを描く
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            for (int i = 0; i <= 10 * SIZE; i++)
            {
                time = i / (10.0F * SIZE);
                x = (float)Math.Sin(omega_x * time);      　　//論理上の横軸値
                y = (float)Math.Sin(omega_y * time + phi);    //論理上の縦軸値
                xx0 = X0 + i;                                 //横軸グラフ用物理的時間軸
                yy0 = Y0 + (5 - 4 * x) * SIZE;                //横軸グラフ用物理的横軸値
                xx1 = X1 + i;                                 //縦軸グラフ用物理的時間軸
                yy1 = Y1 + (5 - 4 * y) * SIZE;      //縦軸グラフ用物理的縦軸値
                xx2 = X2 + (5 - 4 * x) * SIZE * 2;  //リサージュグラフ用物理的横軸値
                yy2 = Y2 + (5 + 4 * y) * SIZE * 2;  //リサージュグラフ用物理的縦軸値
                if (i != 0)
                {
                    g.DrawLine(Pens.LightGreen, xx0_old, yy0_old, xx0, yy0);  //横軸グラフを描く
                    g.DrawLine(Pens.LightGreen, xx1_old, yy1_old, xx1, yy1);  //縦軸グラフを描く
                    g.DrawLine(Pens.LightGreen, xx2_old, yy2_old, xx2, yy2);  //リサージュグラフを描く
                }
                xx0_old = xx0;
                yy0_old = yy0;
                xx1_old = xx1;
                yy1_old = yy1;
                xx2_old = xx2;
                yy2_old = yy2;
                if (slow_flag) System.Threading.Thread.Sleep(20);   //20msec待つ
            }
            slow_flag = false;    //フラグを元に戻しておく
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            Invalidate();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            Invalidate();
        }

        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            Invalidate();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            slow_flag = true;
            Invalidate();
        }
    }
}
