﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp6
{
    public partial class Form1 : Form
    {
        const int X0 = 50, Y0 = 60;
        Rectangle graph_area = new Rectangle(X0, Y0, 600, 400);
        const int MAX_POINTS = 20;
        PointF[] data = new PointF[MAX_POINTS];
        int data_number = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            int i, j;
            float xx, yy;

            //薄く線を引く
            for (i = 0; i <= 60; i++)      //横
                g.DrawLine(Pens.LightGray, X0 + 10 * i, Y0, X0 + 10 * i, Y0 + 400);
            for (j = 0; j <= 40; j++)      //縦
                g.DrawLine(Pens.LightGray, X0, Y0 + 10 * j, X0 + 600, Y0 + 10 * j);
            //濃く線を引き目盛を入れる
            String string1;
            for (i = 0; i <= 12; i++)      //横
            {
                g.DrawLine(Pens.Gray, X0 + 50 * i, Y0, X0 + 50 * i, Y0 + 400);
                string1 = String.Format("{0}", 5 * i);
                g.DrawString(string1, Font, Brushes.Black, X0 - 15 + 50 * i, Y0 + 410);
            }
            for (j = 0; j <= 8; j++)      //縦
            {
                g.DrawLine(Pens.Gray, X0, Y0 + 50 * j, X0 + 600, Y0 + 50 * j);
                string1 = String.Format("{0}", 5 * (8 - j));
                g.DrawString(string1, Font, Brushes.Black, X0 - 30, Y0 - 6 + 50 * j);
            }
            //データ点を表示する
            Pen pen1 = new Pen(Color.Black, 2);
            for (i = 0; i < data_number; i++)
            {
                xx = X0 + data[i].X * 10;
                yy = Y0 + (40 - data[i].Y) * 10;
                g.DrawEllipse(pen1, xx - 3, yy - 3, 6F, 6F);
            }
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            Graphics g = CreateGraphics();

            //前の表示を消す
            g.FillRectangle(Brushes.White, X0 - 5, Y0 + 446, 90, 20);
            //方眼紙の範囲内であれば
            if (graph_area.Contains(e.X, e.Y))
            {
                //データ値に変換する
                float x = (e.X - X0) / 10F;
                float y = 40 - (e.Y - Y0) / 10F;
                //前の表示を消して、新しいデータ値を表示する
                String string1;
                string1 = String.Format("X={0}, Y={1}", x, y);
                g.DrawString(string1, Font, Brushes.Black, X0, Y0 + 450);
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            Graphics g = CreateGraphics();

            //方眼紙の範囲内であれば
            if (graph_area.Contains(e.X, e.Y))
            {
                //データ値に変換する
                float x = (e.X - X0) / 10F;
                float y = 40 - (e.Y - Y0) / 10F;
                try
                {
                    //データ値を格納する
                    data[data_number].X = x;
                    data[data_number].Y = y;
                    data_number++;
                }
                catch (IndexOutOfRangeException)
                {
                    MessageBox.Show("入力点の数が多すぎます", "エラー", MessageBoxButtons.OK);
                }
                //データ点を描画する
                Pen pen1 = new Pen(Color.Black, 2F);
                g.DrawEllipse(pen1, e.X - 3F, e.Y - 3F, 6F, 6F);
            }
        }

        private void Line_Click(object sender, EventArgs e)
        {
            if (data_number < 2) return;

            Graphics g = CreateGraphics();
            PointF[] pdata = new PointF[data_number];

            for (int i = 0; i < data_number; i++)
            {
                pdata[i].X = X0 + data[i].X * 10;
                pdata[i].Y = Y0 + (40 - data[i].Y) * 10;
            }
            Pen pen1 = new Pen(Color.Gray, 2F);
            g.DrawLines(pen1, pdata);
        }

        private void Spline_Click(object sender, EventArgs e)
        {
            if (data_number < 2) return;

            Graphics g = CreateGraphics();
            PointF[] pdata = new PointF[data_number];

            for (int i = 0; i < data_number; i++)
            {
                pdata[i].X = X0 + data[i].X * 10;
                pdata[i].Y = Y0 + (40 - data[i].Y) * 10;
            }
            Pen pen1 = new Pen(Color.Black, 2F);
            pen1.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
            g.DrawCurve(pen1, pdata);
        }

        private void InterClear_Click(object sender, EventArgs e)
        {
            Invalidate();
        }

        private void AllClear_Click(object sender, EventArgs e)
        {
            data_number = 0;
            Invalidate();
        }
    }
}
