﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            //変換テーブルを作成する
            byte[] lowExpand = new byte[256];  //低濃度部の拡張用
            byte[] highExpand = new byte[256]; //高濃度部の拡張用
            byte[] midExpand = new byte[256];  //中濃度部の拡張用          
            for (int i = 0; i < 256; i++)
            {
                lowExpand[i] = (byte)(255 * Math.Sqrt(i / 255.0));
                highExpand[i] = (byte)(255 * Math.Pow(i / 255.0, 2));
                midExpand[i] = (byte)(127.5 * (1 - Math.Cos(Math.PI / 255 * i)));
            }

            // -------- トーンカーブをグラフで描画する --------
            //枠を描く
            g.DrawRectangle(Pens.Black, 40, 32, 128, 128);
            g.DrawRectangle(Pens.Black, 200, 32, 128, 128);
            g.DrawRectangle(Pens.Black, 360, 32, 128, 128);
            //グラフの描画ポイントを用意する
            PointF[] point1 = new PointF[256];
            PointF[] point2 = new PointF[256];
            PointF[] point3 = new PointF[256];
            for(int i = 0; i < 256; i++)
            {
                point1[i].X = 40 + i / 2F;
                point1[i].Y = 160 - lowExpand[i] / 2F;
                point2[i].X = 200 + i / 2F;
                point2[i].Y = 160 - highExpand[i] / 2F;
                point3[i].X = 360 + i / 2F;
                point3[i].Y = 160 - midExpand[i] / 2F;
            }
            //グラフを描く
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            g.DrawLines(Pens.Black, point1);
            g.DrawLines(Pens.Black, point2);
            g.DrawLines(Pens.Black, point3);
            //文字を入れる
            g.DrawString("低濃度部の拡張", Font, Brushes.Black, 60, 180);
            g.DrawString("高濃度部の拡張", Font, Brushes.Black, 220, 180);
            g.DrawString("中濃度部の拡張", Font, Brushes.Black, 380, 180);

            // --------- トーンカーの効果を濃淡で示す ---------
            Color color1;
            Pen pen1;
            byte d;

            //黄色い枠を描く
            g.FillRectangle(Brushes.Yellow, 50, 225, 425, 230);
            g.DrawString("　　 原画像 　　", Font, Brushes.Black, 350, 260);
            g.DrawString("低濃度部拡張画像", Font, Brushes.Black, 350, 310);
            g.DrawString("高濃度部拡張画像", Font, Brushes.Black, 350, 360);
            g.DrawString("中濃度部拡張画像", Font, Brushes.Black, 350, 410);
            //濃淡で表示する
            for(int i = 0; i < 256; i++)
            {
                //原画像
                color1 = Color.FromArgb(i, i, i);
                pen1 = new Pen(color1);
                g.DrawLine(pen1, 70 + i, 245, 70 + i, 285);
                //低濃度部拡張画像
                d = lowExpand[i];
                color1 = Color.FromArgb(d, d, d);
                pen1 = new Pen(color1);
                g.DrawLine(pen1, 70 + i, 295, 70 + i, 335);
                //高濃度部拡張画像
                d = highExpand[i];
                color1 = Color.FromArgb(d, d, d);
                pen1 = new Pen(color1);
                g.DrawLine(pen1, 70 + i, 345, 70 + i, 385);
                //中濃度部拡張画像
                d = midExpand[i];
                color1 = Color.FromArgb(d, d, d);
                pen1 = new Pen(color1);
                g.DrawLine(pen1, 70 + i, 395, 70 + i, 435);
            }
        }
    }
}
