﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp9
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics gr = e.Graphics;
            int WIDTH = 320, HEIGHT = 240;
            int X0 = 10, Y0 = 10;             //左上の画像位置
            int X1 = WIDTH + 20, Y1 = Y0;     //右上の画像位置
            int X2 = X0, Y2 = HEIGHT + 20;    //左下の画像位置
            int X3 = X1, Y3 = Y2;             //右下の画像位置
            Color color0, color1, color2, color3;
            byte r0, g0, b0, r1, g1, b1, r2, g2, b2, r3, g3, b3;
            Bitmap bmap1 = new Bitmap(WIDTH, HEIGHT);  //低濃度部拡張画像
            Bitmap bmap2 = new Bitmap(WIDTH, HEIGHT);  //高濃度部拡張画像
            Bitmap bmap3 = new Bitmap(WIDTH, HEIGHT);  //中濃度部拡張画像
            //変換テーブル
            byte[] lowExpand = new byte[256];  //低濃度部の拡張用
            byte[] highExpand = new byte[256]; //高濃度部の拡張用
            byte[] midExpand = new byte[256];  //中濃度部の拡張用

            //変換テーブルを作成する           
            for (int i = 0; i < 256; i++)
            {
                lowExpand[i] = (byte)(255 * Math.Sqrt(i / 255.0));
                highExpand[i] = (byte)(255 * Math.Pow(i / 255.0, 2));
                midExpand[i] = (byte)(127.5 * (1 - Math.Cos(Math.PI / 255 * i)));
            }
            //原画像を読み込んで、原画像bmap0を生成する
            Bitmap bmap0 = new Bitmap("sample.jpg");
            //原画像を左上に表示する
            gr.DrawImage(bmap0, X0, Y0, WIDTH, HEIGHT);
            //原画像をRGBに分解し、補正して表示する
            for (int j = 0; j < HEIGHT; j++)
                for (int i = 0; i < WIDTH; i++)
                {
                    color0 = bmap0.GetPixel(i, j);
                    r0 = color0.R;
                    g0 = color0.G;
                    b0 = color0.B;
                    //低濃度部拡張
                    r1 = lowExpand[r0];
                    g1 = lowExpand[g0];
                    b1 = lowExpand[b0];
                    color1 = Color.FromArgb(r1, g1, b1);
                    bmap1.SetPixel(i, j, color1);
                    //高濃度部拡張
                    r2 = highExpand[r0];
                    g2 = highExpand[g0];
                    b2 = highExpand[b0];
                    color2 = Color.FromArgb(r2, g2, b2);
                    bmap2.SetPixel(i, j, color2);
                    //中濃度部拡張
                    r3 = midExpand[r0];
                    g3 = midExpand[g0];
                    b3 = midExpand[b0];
                    color3 = Color.FromArgb(r3, g3, b3);
                    bmap3.SetPixel(i, j, color3);
                }
            //補正した画像を表示する
            gr.DrawImage(bmap1, X1, Y1);
            gr.DrawImage(bmap2, X2, Y2);
            gr.DrawImage(bmap3, X3, Y3);
        }
    }
}
